## previsat 3.5.1.7%2Bdfsg1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf inc
	rm -f *.qm

override_dh_auto_configure:
	mkdir -p inc/
	ln -s /usr/include/vlc inc
	mkdir -p inc/zlib
	ln -s /usr/include/zlib.h inc/zlib
	export QT_SELECT=5; dh_auto_configure
	lrelease -qt5 PreviSat.pro

override_dh_dwz:
	@echo not running dh_dwz because it fails unexpectedly

DESTDIR = $(CURDIR)/debian/previsat

override_dh_auto_install:
	dh_auto_install
	# add a symlink to the manpage
	install -d $(DESTDIR)/usr/share/man/man1
	ln -s previsat.1.gz $(DESTDIR)/usr/share/man/man1/PreviSat.1.gz
	# don't know why, this hack is necessary:
	install -d $(DESTDIR)/usr/bin
	install -m 755 PreviSat $(DESTDIR)/usr/bin
	install -d $(DESTDIR)/usr/share/Astropedia/PreviSat
	install -m 644 *.qm $(DESTDIR)/usr/share/Astropedia/PreviSat

## previsat 7.2.0.3

=== CMakeLists.txt ===
#
#     PreviSat, Satellite tracking software
#     Copyright (C) 2005-2025  Astropedia web: http://previsat.free.fr  -  mailto: previsat.app@gmail.com
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# _______________________________________________________________________________________________________
#
# Nom du fichier
# >    CMakeLists.txt
#
# Localisation
# >
#
# Description
# >    Fichier de configuration du projet
#
# Auteur
# >    Astropedia
#
# Date de creation
# >    21 juin 2023
#
# Date de revision
# >    19 octobre 2025
#

cmake_minimum_required(VERSION 3.24)


#----------------------------------
set(VERSION 7.2.0.3)
set(ANNEES_DEV 2005-2025)
set(QT_PREFERRED_VERSION 6.9.2)

if(NOT DEFINED PORTABLE_BUILD)
    set(PORTABLE_BUILD false)
endif()

if(NOT DEFINED BUILD_TEST)
    set(BUILD_TEST false)
endif()

if(NOT DEFINED CLEANUP_TEST)
    set(CLEANUP_TEST true)
endif()

if(NOT DEFINED COVERAGE_TEST)
    set(COVERAGE_TEST false)
endif()
#----------------------------------


set(TARGET PreviSat)
set(DOMAIN_NAME http://previsat.free.fr/)
set(ORG_NAME Astropedia)
set(MAILTO previsat.app@gmail.com)

# Definition du projet
project(${TARGET} VERSION ${VERSION} LANGUAGES CXX)

set(VER_MAJ ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR})

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Icone
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set(app_icon "${CMAKE_CURRENT_SOURCE_DIR}/icone.rc")
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOSX_BUNDLE_ICON_FILE icone.icns)
    set(app_icon "${CMAKE_CURRENT_SOURCE_DIR}/resources/interface/icone.icns")
    set_source_files_properties(${app_icon}
        PROPERTIES
        MACOSX_PACKAGE_LOCATION "Resources"
    )
endif()

find_package(QT NAMES Qt6 REQUIRED COMPONENTS Concurrent Core Multimedia Network PrintSupport Sql Widgets Xml)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Concurrent Core Multimedia Network PrintSupport Sql Widgets Xml)


# Verification de la version de Qt
string(SUBSTRING ${QT_PREFERRED_VERSION} 0 1 QT_PREFERRED_VERSION_MAJOR)

if(NOT ${QT_VERSION_MAJOR} EQUAL ${QT_PREFERRED_VERSION_MAJOR})
    message(FATAL_ERROR "Qt ${QT_VERSION} is not suited to compile ${TARGET}. Use Qt ${QT_PREFERRED_VERSION} in preference")
endif()


# Ajout des definitions
add_compile_definitions(
    APP_NAME="${TARGET}"
    DOMAIN_NAME="${DOMAIN_NAME}"
    ORG_NAME="${ORG_NAME}"
    MAILTO="${MAILTO}"
    VERSION="${VERSION}"
    VER_MAJ="${VER_MAJ}"
    ANNEES_DEV="${ANNEES_DEV}"
    NB_LIGNES="${NB_LIGNES}"
)

add_definitions(
    -DBUILD_TEST=${BUILD_TEST}
    -DPORTABLE_BUILD=${PORTABLE_BUILD}
    -DCLEANUP_TEST=${CLEANUP_TEST}
    -DCOVERAGE_TEST=${COVERAGE_TEST}
    -DQT_MESSAGELOGCONTEXT
)

include_directories(src)

# Definition des librairies
file(GLOB_RECURSE
    LIBRARY_SOURCES
    src/librairies/*.cpp
    src/librairies/*.h
)

# Definition des classes de configuration
file(GLOB_RECURSE
    CONFIGURATION_SOURCES
    src/configuration/*.cpp
    src/configuration/*.h
)

# Definition des classes de previsions
file(GLOB_RECURSE
    PREVISIONS_SOURCES
    src/previsions/*.cpp
    src/previsions/*.h
)

if(${BUILD_TEST})

    message("Build test configuration")

    enable_testing()

    if(${COVERAGE_TEST})
        set(COV_FLAGS -g -fprofile-arcs -ftest-coverage)
        set(COV_LINK_FLAGS -coverage -lgcov)
    endif()

    set(TARGET ${TARGET}Test)

    include_directories(test/src)

    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Test)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)

    file(GLOB_RECURSE
        TEST_SOURCES
        test/src/*.cpp
        test/src/*.h
    )

    add_executable(${TARGET}
        ${TEST_SOURCES}
        ${PREVISIONS_SOURCES}
        ${CONFIGURATION_SOURCES}
        ${LIBRARY_SOURCES}
        src/interface/afficherresultats.cpp
        src/interface/afficherresultats.h
        src/interface/ciel/ciel.cpp
        src/interface/ciel/ciel.h
        src/interface/onglets/general/general.cpp
        src/interface/onglets/general/general.h
        src/interface/onglets/osculateurs/osculateurs.cpp
        src/interface/onglets/osculateurs/osculateurs.h
        src/interface/onglets/donnees/informationssatellite.cpp
        src/interface/onglets/donnees/informationssatellite.h
        src/interface/onglets/donnees/recherchesatellite.cpp
        src/interface/onglets/donnees/recherchesatellite.h
        src/interface/onglets/previsions/calculsflashs.cpp
        src/interface/onglets/previsions/calculsflashs.h
    )

    add_test(NAME ${TARGET} COMMAND ${TARGET})

    target_link_libraries(
        ${TARGET}
        PRIVATE
        Qt${QT_VERSION_MAJOR}::Concurrent
        Qt${QT_VERSION_MAJOR}::Multimedia
        Qt${QT_VERSION_MAJOR}::Network
        Qt${QT_VERSION_MAJOR}::Sql
        Qt${QT_VERSION_MAJOR}::Test
        Qt${QT_VERSION_MAJOR}::Widgets
        Qt${QT_VERSION_MAJOR}::Xml
        ${COV_LINK_FLAGS}
    )

else()

    if(${PORTABLE_BUILD})
        message("Build portable software configuration")
    else()
        message("Build software configuration")
    endif()

    # Definition des classes d'interface graphique
    file(GLOB_RECURSE
        INTERFACE_SOURCES
        src/interface/*.cpp
        src/interface/*.h
        src/interface/*.ui
    )

    if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")

        file(GLOB_RECURSE
            TELESCOPE_SOURCES
            src/interface/onglets/telescope/*.cpp
            src/interface/onglets/telescope/*.h
            src/interface/onglets/telescope/*.ui
        )

        list(REMOVE_ITEM
            INTERFACE_SOURCES
            ${TELESCOPE_SOURCES}
        )
    endif()

    qt_add_resources(${CMAKE_CURRENT_SOURCE_DIR}/resources.qrc)

    qt_add_executable(${TARGET}
        MANUAL_FINALIZATION
        src/main.cpp
        ${INTERFACE_SOURCES}
        ${PREVISIONS_SOURCES}
        ${CONFIGURATION_SOURCES}
        ${LIBRARY_SOURCES}
        ${app_icon}
        resources.qrc
    )

    target_link_libraries(${TARGET}
        PRIVATE
        Qt${QT_VERSION_MAJOR}::Concurrent
        Qt${QT_VERSION_MAJOR}::Multimedia
        Qt${QT_VERSION_MAJOR}::Network
        Qt${QT_VERSION_MAJOR}::PrintSupport
        Qt${QT_VERSION_MAJOR}::Sql
        Qt${QT_VERSION_MAJOR}::Widgets
        Qt${QT_VERSION_MAJOR}::Xml
    )

    if(${QT_VERSION} VERSION_LESS 6.1.0)
      set(BUNDLE_ID_OPTION MACOSX_BUNDLE_GUI_IDENTIFIER com.astropedia.previsat)
    endif()

    set_target_properties(${TARGET} PROPERTIES
        ${BUNDLE_ID_OPTION}
        MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
        MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        MACOSX_BUNDLE TRUE
        WIN32_EXECUTABLE TRUE
    )

    qt_finalize_executable(${TARGET})

    if(${CMAKE_BUILD_TYPE} STREQUAL "Release")

        set(RELEASE_FLAGS
            -Os
            -fbounds-check
            -fbranch-target-load-optimize
            -fcaller-saves
            -fcommon
            -fcprop-registers
            -fcrossjumping
            -floop-optimize
            -foptimize-register-move
            -fpeephole
            -fpeephole2
            -frerun-cse-after-loop
            -fstrength-reduce
            -malign-double
            -s
        )

        set(LANGUAGE_OPTIONS
            -no-obsolete
        )
    endif()

    if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS LinguistTools)
        qt_add_translations(${TARGET}
            TS_FILES translations/PreviSat_en.ts translations/PreviSat_ja.ts
            LUPDATE_OPTIONS ${LANGUAGE_OPTIONS}
        )

        add_dependencies(${TARGET} ${TARGET}_lupdate)
        add_dependencies(${TARGET} update_translations)
    endif()

endif()

target_compile_options(${TARGET}
    PUBLIC
    ${COV_FLAGS}
    ${RELEASE_FLAGS}
    -W
    -Wall
    -Wcast-align
    -Wcast-qual
    -Wchar-subscripts
    -Wcomment
    -Wconversion
    -Wextra
    -Wfloat-equal
    -Wformat
    -Wformat-nonliteral
    -Wformat-security
    -Wformat-y2k
    -Wformat=2
    -Wignored-qualifiers
    -Wimport
    -Winit-self
    -Winvalid-pch
    -Wmain
    -Wmissing-declarations
    -Wmissing-field-initializers
    -Wmissing-format-attribute
    -Wmissing-noreturn
    -Wno-deprecated-declarations
    -Wpacked
    -Wparentheses
    -Wpointer-arith
    -Wredundant-decls
    -Wreturn-type
    -Wsequence-point
    -Wshadow
    -Wsign-compare
    -Wstack-protector
    -Wswitch
    -Wswitch-default
    -Wswitch-enum
    -Wtrigraphs
    -Wundef
    -Wuninitialized
    -Wunknown-pragmas
    -Wunreachable-code
    -Wunused
    -Wunused-parameter
    -Wvariadic-macros
    -Wwrite-strings
    -pipe
)

get_target_property(MAIN_CFLAGS ${TARGET} COMPILE_OPTIONS)
message("-- Compiler flags are ${MAIN_CFLAGS}")

add_custom_command(TARGET ${TARGET} POST_BUILD
    COMMAND echo Compiler flags are ${MAIN_CFLAGS}
    COMMAND echo "QT_VERSION     = ${QT_VERSION}"
    COMMAND echo "APP_NAME       = ${TARGET}"
    COMMAND echo "DOMAIN_NAME    = ${DOMAIN_NAME}"
    COMMAND echo "ORG_NAME       = ${ORG_NAME}"
    COMMAND echo "VERSION        = ${VERSION}"
    COMMAND echo "VER_MAJ        = ${VER_MAJ}"
    COMMAND echo "ANNEES_DEV     = ${ANNEES_DEV}"
    COMMAND echo "PORTABLE_BUILD = ${PORTABLE_BUILD}"
    COMMAND echo "CLEANUP_TEST   = ${CLEANUP_TEST}"
    COMMAND echo "COVERAGE_TEST  = ${COVERAGE_TEST}"
    COMMAND echo "BUILD_TEST     = ${BUILD_TEST}"
)

message(
    "Compiler flags are ${MAIN_CFLAGS}\n\n"
    "QT_VERSION     = ${QT_VERSION}\n"
    "APP_NAME       = ${TARGET}\n"
    "DOMAIN_NAME    = ${DOMAIN_NAME}\n"
    "ORG_NAME       = ${ORG_NAME}\n"
    "VERSION        = ${VERSION}\n"
    "VER_MAJ        = ${VER_MAJ}\n"
    "ANNEES_DEV     = ${ANNEES_DEV}\n"
    "PORTABLE_BUILD = ${PORTABLE_BUILD}\n"
    "CLEANUP_TEST   = ${CLEANUP_TEST}\n"
    "COVERAGE_TEST  = ${COVERAGE_TEST}\n"
    "BUILD_TEST     = ${BUILD_TEST}\n"
)

## previsat 3.5.1.7+dfsg1

=== debian/changelog ===
previsat (3.5.1.7+dfsg1-4) unstable; urgency=medium

  * Fix FTCBFS: Add qt5-qmake:native to Build-Depends for running lrelease.
    (Closes: #969643), thanks to Helmut Grohne's patch!
  * upgraded to debhelper-compat (= 12), Standards-Version: 4.5.0
  * introduced a an empy target override_dh_dwz: in debian/rules
    to prevent dh_dwz failure

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 06 Sep 2020 17:19:31 +0200

previsat (3.5.1.7+dfsg1-3) unstable; urgency=medium

  * created VCS stuff in d/control
  * upgraded Standards-Version: 4.2.1 and dh level : 11
  * fixed the location of command data in the file previsat.cpp. Closes: #915330
  * added a call to lrelease, added PreviSat_en.qm to installable files,
    modified main.cpp to search language files under
    /usr/share/Astropedia/PreviSat
  * added a build-dependency on qttools5-dev-tools

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 03 Dec 2018 19:19:06 +0100

previsat (3.5.1.7+dfsg1-2) unstable; urgency=medium

  * replaced the macro __DATE__ with "Jun 30 2016"; this should ensure
    a reproducible build.
  * changes for gcc6: patched librairies/corps/satellite/sgp4.h and checked
    the compilation with g++-6. Closes: #812030
  * updated Standards-Version

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 30 Jun 2016 14:28:55 +0200

previsat (3.5.1.7+dfsg1-1) unstable; urgency=medium

  * upgraded to the upstream package
  * repackaged the source, to add PDF's source and compile them with
    LibreOffice.

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 08 Feb 2016 11:20:24 +0100

previsat (3.5.0.8+dfsg1-2) unstable; urgency=medium

  * removed the post-installation routine, added documentation files
    sent by the author in private e-mail, rewritten the file
    doc/README.txt to inform users that the PDF files were not generated
    with Microsoft Office.

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 09 Jan 2016 18:06:56 +0100

previsat (3.5.0.8+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #761512)
  * written a short manpage
  * repackaged the source to remove sourceless PDF documents;
    added a download procedure during the post-installation to
    retrieve costless PDF documents from http:/previsat.sourceforge.net

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 01 Jan 2016 20:13:26 +0100

=== debian/control ===
Source: previsat
Section: x11
Priority: optional
Maintainer: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper-compat (= 12),
 qtbase5-dev,
 qt5-qmake,
 qt5-qmake:native,
 libqt5webkit5-dev,
 qtmultimedia5-dev,
 qttools5-dev-tools,
 libvlc-dev,
 zlib1g-dev
Standards-Version: 4.5.0
Homepage: http://astropedia.free.fr
Vcs-Browser: https://salsa.debian.org/georgesk/previsat
Vcs-Git: https://salsa.debian.org/georgesk/previsat.git

Package: previsat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: satellite tracking software for observing purposes
 Previsat is very easy to use, it shows positions of artificial
 satellites in real-time or manual mode. PreviSat is able to make
 predictions of their passes and also predictions of Iridium flares.

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@
+	dh $@ 
 
 override_dh_auto_clean:
 	dh_auto_clean

## previsat 6.1.5.2

=== debian/changelog ===
previsat (6.1.5.2-2) unstable; urgency=medium

  * use the flag -malign-double only with a few architectures

 -- Georges Khaznadar <georgesk@debian.org>  Tue, 21 Jan 2025 10:44:46 +0100

previsat (6.1.5.2-1) unstable; urgency=medium

  * fixed debian/watch
  * New upstream version 6.1.5.2
  * updated build dependencies, as Qt is now Qt6. Closes: #1093527
  * bumped Standards-Version: 4.7.0
  * simplified debian/rules

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 20 Jan 2025 14:38:08 +0100

previsat (3.5.1.7+dfsg1-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Archive, Bug-Database, Repository.
  * Update standards version to 4.6.0, no changes needed.

  [Georges Khaznadar]
  * Bumped Standards-Version: 4.6.2
  
 -- Georges Khaznadar <georgesk@debian.org>  Tue, 21 Feb 2023 18:51:27 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Section: x11
 Priority: optional
 Maintainer: Georges Khaznadar <georgesk@debian.org>
-Build-Depends: debhelper-compat (= 12),
- qtbase5-dev,
- qt5-qmake,
- qt5-qmake:native,
- libqt5webkit5-dev,
- qtmultimedia5-dev,
- qttools5-dev-tools,
- libvlc-dev,
- zlib1g-dev
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13),
+ cmake,
+ cmake-data,
+ extra-cmake-modules (>= 6.0.0),
+ pkgconf,
+ qt6-base-dev,
+ qt6-multimedia-dev,
+ libxkbcommon-dev,
+ qt6-l10n-tools,
+Standards-Version: 4.7.0
 Homepage: http://astropedia.free.fr
 Vcs-Browser: https://salsa.debian.org/georgesk/previsat
 Vcs-Git: https://salsa.debian.org/georgesk/previsat.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=qmake6

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .qm/ release/

DESTDIR = $(CURDIR)/debian/previsat

=== debian/watch ===
version=4

# SourceForge hosted projects.
opts="repack, repacksuffix=dfsg, uversionmangle=s/-src//" \
  http://sf.net/previsat/ previsat-(.*)\.tar\.gz

## previsat 7.2.0.3

=== debian/changelog ===
previsat (7.2.0.3-1) unstable; urgency=medium

  * New upstream version 7.2.0.3

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 07 Dec 2025 18:28:13 +0100

previsat (7.1.0.6-1) UNRELEASED; urgency=medium

  * New upstream version 7.1.0.6
  * enforced the use of gcc-15, checked the build, patched file
    src/configuration/configuration.cpp, and then dismissed gcc-15's
    enforcement. Closes: #1097648
  * added a build dependency: dh-cmake
  * bumped Standards-Version: 4.7.2

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 21 Mar 2025 17:39:57 +0100

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
  cmake,
  cmake-data,
  extra-cmake-modules (>= 6.0.0),
+ dh-cmake,
  pkgconf,
  qt6-base-dev,
  qt6-multimedia-dev,
  libxkbcommon-dev,
  qt6-l10n-tools,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: http://astropedia.free.fr
 Vcs-Browser: https://salsa.debian.org/georgesk/previsat
 Vcs-Git: https://salsa.debian.org/georgesk/previsat.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	: # on amd64 architecture, the executable is in
	: # obj-x86_64-linux-gnu/PreviSat
	install -d debian/previsat/usr/bin
	install -m 755 $$(find obj* -name PreviSat) debian/previsat/usr/bin

DESTDIR = $(CURDIR)/debian/previsat
